class mdt_handlers:EventHandler{
	override void WorldThingSpawned(WorldEvent e){
		if(e.thing is "Weapon"){
			ThingSpawnReplace(e.thing,"chainsaw","mdt_chainsaw");
			ThingSpawnReplace(e.thing,"fist","mdt_fist");
			ThingSpawnReplace(e.thing,"pistol","mdt_pistol");
			ThingSpawnReplace(e.thing,"shotgun","mdt_shotgun");
			ThingSpawnReplace(e.thing,"supershotgun","mdt_supershotgun");
			ThingSpawnReplace(e.thing,"chaingun","mdt_chaingun");
			ThingSpawnReplace(e.thing,"rocketlauncher","mdt_rocketlauncher");
			ThingSpawnReplace(e.thing,"plasmarifle","mdt_plasmarifle");
			ThingSpawnReplace(e.thing,"bfg9000","mdt_bfg");
		}
		if(e.thing is "PlayerPawn"){
			let ppp=playerpawn(e.thing);
			ppp.viewheight=max(ppp.viewheight,48);
			ppp.attackzoffset=max(ppp.attackzoffset,16);
			if(ppp.player)ppp.player.crouchfactor=0.9;
			return;
		}
		if(e.thing is "Blood")e.thing.A_StartSound("weapons/bulletblood",pitch:frandom(0.6,0.8));
		if(e.thing is "ExplosiveBarrel")e.thing.bforcepain=true;
		ProcessProjectile(e.thing);
		ThingSpawnReplace(e.thing,"armorbonus","mdt_armorbonus");
		ThingSpawnReplace(e.thing,"berserk","mdt_berserk");
	}

	void ThingSpawnReplace(actor replacee,class<actor> replaceeclass,class<actor> replacer){
		if(!replacee||replacee.getclass()!=replaceeclass)return;
		inventory ething=inventory(replacee);
		if(ething&&ething.owner){
			let ammog=getdefaultbytype((class<weapon>)(replacer)).ammotype1;
			int ammount1=ething.owner.countinv(ammog);
			ammog=getdefaultbytype((class<weapon>)(replacer)).ammotype2;
			int ammount2=ething.owner.countinv(ammog);

			ething.owner.A_GiveInventory((class<inventory>)(replacer));
			if(
				replacer is "Weapon"
				&&ething.owner.player
				&&replacee==ething.owner.player.readyweapon
			){
				ething.owner.A_SelectWeapon((class<weapon>)(replacer));
				ething.owner.A_SetInventory(getdefaultbytype((class<weapon>)(replacer)).ammotype1,ammount1);
				ething.owner.A_SetInventory(getdefaultbytype((class<weapon>)(replacer)).ammotype2,ammount2);
			}
		}else{
			let nthing=actor.spawn(replacer,replacee.pos);
			nthing.angle=replacee.angle;
			nthing.pitch=replacee.pitch;
			nthing.special=replacee.special;
			nthing.bambush=replacee.bambush;
			nthing.bdormant=replacee.bdormant;
			nthing.bfriendly=replacee.bfriendly;
			nthing.ChangeTid(replacee.tid);
			for(int i=0;i<5;i++){
				nthing.args[i]=ething.args[i];
			}
			if(ething.bdropped){
				nthing.bdropped=true;
				let nwep=weapon(nthing);
				if(nwep){
					nwep.ammogive1=nwep.ammogive1>>1;
					nwep.ammogive2=nwep.ammogive2>>1;
				}
			}else nthing.bdropped=false;
		}
		if(replacee.bismonster){
			if(replacee.bcountkill){
				level.total_monsters--;
				level.killed_monsters--;
			}
		}
		replacee.destroy();
	}

	//sometimes OBLIGE will give you lots of hitscanners between you and the only healing items.
	int hurttracker;
	override void WorldThingDamaged(WorldEvent e){
		if(
			!multiplayer
			&&e.thing==players[0].mo
			&&e.thing.health>0
		){
			hurttracker=0;
		}
	}
	int lastpmohealth;
	override void WorldTick(){
		if(
			!multiplayer
			&&playeringame[0]
		){
			if(players[0].cmd.buttons&(BT_ATTACK|BT_ALTATTACK))hurttracker=0;
			else if(
				!(level.time&(1|2|4|8|16))
				&&players[0].mo
				&&players[0].mo.health<50
				&&players[0].mo.health>0
			){
				actor pmo=players[0].mo;
				if(pmo.health!=lastpmohealth)lastpmohealth=pmo.health;
				else if(hurttracker>16){
					pmo.givebody(50-pmo.health);
					pmo.A_Log("Health restored during rest.",true);
				}else hurttracker++;
			}
		}
	}


	//modify projectiles to avoid looking up lighting and decal definitions
	void ProcessProjectile(actor proj){
		if(
			!proj
			||!proj.bmissile
		)return;
		proj.A_SetSize(min(proj.radius,6),min(proj.height,8));

		let cll=proj.getclass();
		if(
			cll=="DoomImpBall"
			||cll=="CacodemonBall"
			||cll=="BaronBall"
			||cll=="RevenantTracer"
			||cll=="mdt_rocket"
		){
			ProjectileLeadTarget(proj);
			proj.bdontfacetalker=true;
		}

		if(cll=="BaronBall")proj.vel*=1.2;

		if(
			proj.target
			&&proj.bdontfacetalker  //no one's going to use this, right?????
		){
			if(proj.bnoteleport){
				proj.bnoteleport=false;
				proj.bnotelestomp=true;
			}
			proj.vel+=proj.target.vel;
		}
	}
	//redirect projectiles to avoid replacing attack sequences
	static void ProjectileLeadTarget(actor proj){
		if(
			!proj.bmissile
			||proj.speed<10  //originally just check to prevent divide by zero, but super-slow projectiles probably have their own stuff going on
			||!(level.time&3)
			||!proj.target
			||!proj.target.bismonster
			||!proj.target.target
			||proj.target.target.bshadow
			||proj.target.target.pos==proj.target.target.prev
		)return;
		actor tgt=proj.target.target;
		double tgtaimz=tgt.height*0.61803;
		double timetotarget=min(35,tgt.distance3d(proj.target)/proj.speed);
		timetotarget*=frandom(0.4,1.);
		vector3 vvel=tgt.pos-tgt.prev;
		vector3 tstartpos=(tgt.pos.xy,tgt.pos.z+tgtaimz);
		vector3 tendpos=tstartpos+vvel*timetotarget;

		tendpos.z=max(tendpos.z,tgt.floorz+tgtaimz); //don't shoot floor just b/c the target jumped

		vector3 newvel=tendpos-proj.pos; //level.vec3offset never works! don't change this!
		newvel=newvel.unit();
		proj.vel=newvel*proj.speed;
		proj.A_FaceMovementDirection();
		proj.target.angle+=proj.deltaangle(proj.target.angle,proj.angle)*0.5;

		//the rocket accelerates, so its speed is misleading and the leading will be overdone.
		//(actually it just makes the cyberdemon arbitrarily insanely more difficult)
		let rrr=mdt_rocket(proj);
		if(rrr)rrr.accelunit=(newvel*MDT_ROCKETACCELFACTOR+rrr.accelunit)*0.5;
	}


	//looks for additional map marker lumps
	override void OnRegister(){
		string nmaps="";
		for(int i=1;i<33;i++){
			string mmm=(i<10?"MAP0":"MAP")..i;
			let aaa=Wads.FindLump(mmm);
			aaa=Wads.FindLump(mmm,aaa+1);
			if(aaa>-1){
				if(nmaps=="")nmaps="\cy"..mmm;
				else nmaps=nmaps.."\ca,\cy "..mmm;
			}
		}
		for(int i=1;i<5;i++){
			for(int j=1;j<10;j++){
				string mmm="E"..i.."M"..j;
				let aaa=Wads.FindLump(mmm);
				aaa=Wads.FindLump(mmm,aaa+1);
				if(aaa>-1){
					if(nmaps=="")nmaps="\cy"..mmm;
					else nmaps=nmaps.."\ca,\cy "..mmm;
				}
			}
		}
		if(nmaps!="")console.printf("\camdt: custom maps found: \cy"..nmaps);
	}


	//let player warp to a random map
	override void NetworkProcess(ConsoleEvent e){
		if(deathmatch&&!sv_cheats)return;
		if(e.name~=="randommap")randmap();
	}
	void randmap(){
		bool d1=Wads.FindLump("E1M1")>-1;
		name mapname=level.mapname;
		do{
			if(d1){
				int maxeps=3;
				while(
					Wads.FindLump("E"..(maxeps+1).."M1")>-1
				)maxeps++;
				mapname="E"..random(1,maxeps).."M"..random(1,9);
			}else{
				int rnd=random(1,32);
				if(rnd<10)mapname="MAP0"..rnd;
				else mapname="MAP"..rnd;
			}
		}while(mapname==level.mapname);
		console.printf("Now warping to "..mapname..".");
		level.changelevel(mapname,flags:
			CHANGELEVEL_NOINTERMISSION
			|CHANGELEVEL_RESETINVENTORY
			|CHANGELEVEL_RESETHEALTH
		);
	}
}

class mdt_fastprojectile:fastprojectile{
	default{
		+dontfacetalker
		+notelestomp
	}
	override void tick(){
		if(bmissile)super.tick();
		else actor.tick();
	}
}
const MDT_ROCKETACCELFACTOR=7.;
class mdt_rocket:mdt_fastprojectile{
	default{
		+forceradiusdmg -noteleport
		decal "BigScorch";
		height 4;radius 5;
		speed 20;

		+randomize
		+dehexplosion
		+rockettrail
		+zdoomtrans
		damage 20;
		seesound "weapons/rocklf";
		deathsound "weapons/rocklx";
		obituary "$OB_MPROCKET";
	}
	vector3 accelunit;
	override void postbeginplay(){
		super.postbeginplay();
		bforcepain=random(0,4);
		A_FaceMovementDirection();
		accelunit=(angletovector(angle,cos(pitch)),sin(-pitch))*MDT_ROCKETACCELFACTOR;
		A_StartSound("weapons/rocklf");
	}
	void A_Accelerate(){
		vel*=0.9;
		vel+=accelunit;
	}
	states{
	spawn:
		MISL AAAAAAAAAAA 1 light("ROCKET") A_Accelerate();
		MISL A -1 light("ROCKET");
		wait;
	death:
		MISL B 3 bright light("ROCKET_X1"){
			A_SetTranslucent(0.9,1);
			vel=(0,0,1);
			bforcepain=!random(0,4);
			A_Explode(flags:(target&&target.player)?XF_HURTSOURCE:0);
		}
		MISL B 2 bright light("ROCKET_X1") A_Quake(2,24,0,256);
		MISL C 3 bright light("ROCKET_X2") A_AlertMonsters();
		MISL D 4 bright light("ROCKET_X3");
		stop;
	}
}
class mdt_plasmaball:mdt_fastprojectile{
	default{
		height 4; radius 6; damage 5;
		alpha 1.;
		decal "PlasmaScorch";

		+randomize
		+zdoomtrans
		speed 30;
		damage 5;
		renderstyle "add";
		seesound "weapons/plasmaf";
		deathsound "weapons/plasmax";
		obituary "$OB_MPPLASMARIFLE";
	}
	override void postbeginplay(){
		super.postbeginplay();
		A_FaceMovementDirection();
		A_StartSound("weapons/plasmaf");
	}
	states{
	spawn:
		PLSS AA 4 bright light("PLASMABALL");
		loop;
	death:
		PLSE A 4 bright light("PLASMA_X1") A_ChangeVelocity(0,0,1);
		PLSE BC 4 bright light("PLASMA_X2");
		PLSE D 4 bright light("PLASMA_X3");
		PLSE E 4 bright light("PLASMA_X4");
		stop;
	}
}

