class mdt_monsterpuff:bulletpuff{
	default{
		+nointeraction
	}
	states{
	spawn:
		TNT1 A 0 nodelay A_StartSound("weapons/bulletpuff");
		TNT1 A 0 A_SpawnItemEx("BulletPuff",0,0,0,0,0,1,0,SXF_NOCHECKPOSITION);
		stop;
	}
}

mixin class mdt_monster{
	void A_StepForward(
	bool face
	){
		if(face)A_FaceTarget();
		TryMove(pos.xy+(cos(angle),sin(angle))*speed,false);
	}
	void A_MDTFaceTarget(double max_turn,double max_pitch){
		A_FaceTarget(max_turn,max_pitch,flags:FAF_BOTTOM,z_ofs:!target?32:target.height*0.6);
	}
	void A_MDTCGAttack(){
		A_CustomBulletAttack(
			frandom(-5,5),frandom(-5,5),1,5,"mdt_monsterpuff",
			0,CBAF_AIMFACING|CBAF_EXPLICITANGLE
		);
		A_MDTFaceTarget(4,4);
		A_StartSound("weapons/pistol",CHAN_WEAPON,CHANF_OVERLAP);
	}
}

class mdt_zombieman : zombieman replaces zombieman{
	mixin mdt_monster;
	default{
		dropitem "Clip",255,8;
		decal "BulletChip";
		attacksound "";
		health 30;
		speed 10;
		radius 16;
	}
	states{
	missile:
		POSS EE 5 A_MDTFaceTarget(0,0);
		POSS E 0{
			pitch+=frandom(-14,14);
			angle+=frandom(-14,14);
			A_StartSound("weapons/pistol",CHAN_WEAPON);
		}
		POSS F 6 bright A_CustomBulletAttack(0,0,1,6,"mdt_monsterpuff",0,CBAF_AIMFACING|CBAF_EXPLICITANGLE);
		POSS E 8 A_CPosRefire();
		POSS F 0 A_Jump(64,"see");
		POSS EE 4 A_FaceTarget(0,0);
		goto missile+1;
	}
}
class mdt_stealthzombieman:mdt_zombieman replaces stealthzombieman{
	default{+stealth +shadow decal "BulletChip";}
}

class mdt_shotgunguy:shotgunguy replaces shotgunguy{
	mixin mdt_monster;
	default{
		decal "BulletChip";
		attacksound "";
		speed 12;
		radius 16;
	}
	states{
	missile:
		SPOS EE 5 A_MDTFaceTarget(0,0);
		SPOS E 0{
			pitch+=frandom(-14,14);
			angle+=frandom(-14,14);
			A_StartSound("weapons/shotgf",CHAN_WEAPON);
		}
		SPOS EEEEEEE 0 A_CustomBulletAttack(
			frandom(-2,2),frandom(-2,2),1,2,"mdt_monsterpuff",
			0,CBAF_AIMFACING|CBAF_EXPLICITANGLE
		);

		SPOS F 6 bright;
		SPOS E 8;
		goto see;
	}
}
class mdt_stealthshotgunguy:mdt_shotgunguy replaces stealthshotgunguy{
	default{+stealth +shadow decal "BulletChip";}
}

class mdt_chaingunguy:chaingunguy replaces chaingunguy{
	mixin mdt_monster;
	default{
		decal "BulletChip";
		attacksound "";
	}
	states{
	missile:
		CPOS E 8{
			A_MDTFaceTarget(0,0);
			pitch+=frandom(-14,14);
			angle+=frandom(-14,14);
		}
		CPOS F 5 bright A_MDTCGAttack();
		CPOS EF 3 bright A_MDTCGAttack();
	missile2:
		CPOS EFEFEFEFE 2 bright A_MDTCGAttack();
		CPOS F 0 A_Jump((!target||target.bcorpse)?96:16,"see");
		CPOS F 0 A_JumpIfTargetInLOS("missile2",12);
		CPOS FE 3 bright A_MDTCGAttack();
		CPOS F 5 bright A_MDTCGAttack();
		goto see;
	}
}
class mdt_stealthchaingunguy:mdt_chaingunguy replaces stealthchaingunguy{
	default{+stealth +shadow decal "BulletChip";}
}

class mdt_wolfensteinss:wolfensteinss replaces wolfensteinss{
	mixin mdt_monster;
	default{
		decal "BulletChip";
		attacksound "";
		speed 12;
		radius 16;
	}
	states{
	missile:
		SSWV EF 8{
			A_MDTFaceTarget(0,0);
			pitch+=frandom(-14,14);
			angle+=frandom(-14,14);
		}
		SSWV G 2 bright A_MDTCGAttack();
	missile2:
		SSWV F 2;
		SSWV G 1 bright A_MDTCGAttack();
		SSWV F 2;
		SSWV G 1 bright A_MDTCGAttack();
		SSWV F 2;
		SSWV G 1 bright A_MDTCGAttack();
		SSWV F 2;
		SSWV G 1 bright A_MDTCGAttack();
		SSWV F 2;
		SSWV G 1 bright A_MDTCGAttack();
		SSWV F 1 A_Jump(32,"missile2");
		SSWV FE 4;
		SSWV E 0 A_Jump(64,"see");
		SSWV E 0 A_CPosRefire();
		goto missile;
	}
}

class mdt_doomimp:doomimp replaces doomimp{
	default{
		speed 12;
		radius 16;
	}
}
class mdt_stealthdoomimp:mdt_doomimp replaces stealthdoomimp{
	default{+stealth +shadow}
}

class mdt_demon:demon replaces demon{
	default{
		speed 16;
		meleerange 48;
		radius 22;
		health 140;
	}
	mixin mdt_monster;
	states{
	melee:
		SARG EEFF 3 fast A_StepForward(true);
		SARG FF 2 fast A_StepForward(false);
		SARG G 0 fast A_SargAttack;
		SARG GG 4 fast A_StepForward(false);
		goto see;
	}
}
class mdt_spectre:mdt_demon replaces spectre{
	default{
		+shadow;
		renderstyle "fuzzy";;
		hitobituary "$OB_SPECTREHIT";
	}
}
class mdt_stealthdemon:mdt_demon replaces stealthdemon{
	default{+stealth +shadow}
}


class mdt_cacodemon:cacodemon replaces cacodemon{
	default{
		minmissilechance 80;
		health 300;
		radius 30;
		mass 160;
	}
}
class mdt_stealthcacodemon:mdt_cacodemon replaces stealthcacodemon{
	default{+stealth +shadow}
}


class mdt_baronofhell:baronofhell replaces baronofhell{
	default{
		+missileevenmore
		minmissilechance 40;
		painchance 40;
		health 800;
	}
}
class mdt_hellknight:hellknight replaces hellknight{
	default{
		speed 10;
		radius 20;
	}
}
class mdt_stealthhellknight:mdt_hellknight replaces stealthhellknight{
	default{+stealth +shadow}
}

class mdt_arachnotron:arachnotron replaces arachnotron{
	mixin mdt_monster;
	default{
		radius 42;
		attacksound "";
	}
	double shootangle;
	void A_MDTArachAtk(){
		if(absangle(angle,shootangle)>35)setstatelabel("missileabort");
		else A_SpawnProjectile("mdt_arachnotronplasma",flags:CMF_AIMDIRECTION,pitch:pitch);
	}
	states{
	missile:
		BSPI AAA 4 bright A_MDTFaceTarget(0,0);
		BSPI G 0{shootangle=angle;}
	missile2:
		BSPI G 3 bright A_MDTArachAtk();
		BSPI H 3 A_MDTFaceTarget(30,30);
		BSPI G 3 bright A_MDTArachAtk();
		BSPI H 3 A_MDTFaceTarget(10,10);
		BSPI G 3 bright A_MDTArachAtk();
		BSPI H 3 A_MDTFaceTarget(10,10);
		BSPI G 3 bright A_MDTArachAtk();
		BSPI H 3 A_MDTFaceTarget(10,10);
		BSPI G 3 bright A_MDTArachAtk();
		BSPI H 3 A_MDTFaceTarget(20,20);
		BSPI H 0 A_Jump(32,"see");
		BSPI H 0 A_JumpIfTargetInLOS("missile2",10,flags:JLOSF_DEADNOJUMP);
	missileabort:
		BSPI A 6;
		goto see;
	}
}
class mdt_arachnotronplasma:mdt_plasmaball{
	default{
		decal "ArachnotronScorch";
		speed 25;
	}
	states{
	spawn:
		APLS AA 4 bright light("ARACHPLAS");
		loop;
	death:
		APBX A 4 bright light("ARACHPLAS_X1") A_ChangeVelocity(0,0,1);
		APBX BC 4 bright light("ARACHPLAS_X2");
		APBX D 4 bright light("ARACHPLAS_X3");
		APBX E 4 bright light("ARACHPLAS_X4");
		stop;
	}
}

class mdt_vileshot:mdt_fastprojectile{
	default{
		radius 10;
		height 8;
		speed 34;
		+hittracer
	}
	override bool cancollidewith(actor other,bool passive){
		return other.master!=target;
	}
	void A_VileImmolate(actor victim,int startstamina=20){
		let fff=spawn("mdt_vileflame",victim.pos,ALLOW_REPLACE);
		fff.target=target;
		fff.tracer=victim;
		fff.stamina=startstamina;
	}
	int sprd;
	vector3 vu;
	override void postbeginplay(){
		super.postbeginplay();
		if(
			target
			&&target.target
			&&level.ispointinlevel(target.target.pos)
			&&target.checksight(target.target)
		){
			accuracy=int(distance3d(target.target)/vel.length()+1);
		}
		speed=vel.length();
		//it's not accelerating or changing direction after spawn
		sprd=int(speed/radius);
		vu=vel.unit()*radius;
	}
	override void tick(){
		if(isfrozen())return;
		if(
			getage()>accuracy
			||vel==(0,0,0)
		){
			super.tick();
			return;
		}
		for(int i=0;i<sprd;i++){
			setorigin(pos+vu,true);
			if(
				(
					!trymove(pos.xy,true,true)
					&&!!blockingmobj
				)
			){
				accuracy=-1;
				explodemissile(blockingline,blockingmobj);
				return;
			}
		}
		if(CheckNoDelay()){
			if(tics>0)tics--;  
			while(!tics){
				if(!SetState(CurState.NextState)){
					return;
				}
			}
		}
		return;
	}
	states{
	spawn:
		BOSF ABCD 2;
		loop;
	death:
		TNT1 A 20{
			A_StartSound("brain/cubeboom",CHAN_VOICE,CHANF_OVERLAP);
			actor sss=tracer;
			if(sss){
				A_VileImmolate(sss);
				sss.damagemobj(self,target,50,"fire");
				sss.vel.z+=min(20,1200/sss.mass);
			}else if(target&&!target.player){
				let sss=spawn("DoomImp",pos-(cos(angle)*16,sin(angle)*16,pitch),ALLOW_REPLACE);
				if(sss){
					spawn("SpawnFire",sss.pos,ALLOW_REPLACE);
					sss.master=target;
					sss.target=target.target;
					sss.A_GiveInventory("mdt_deathfader");
					sss.pitch=pitch;
					sss.angle=angle;
					sss.A_Face(sss.target);
					sss.damagemobj(null,sss.target,(sss.health*3)>>2,"fire");
					sss.speed*=1.6;
					sss.minmissilechance>>=2;
					sss.A_SetTranslucent(1,1);
					sss.bsolid=false;
					sss.bnoblood=true;
					sss.bnopain=true;
					sss.bfriendly=target.bfriendly;
					sss.species=target.species;
					sss.bdontharmspecies=true;
				}
			}else spawn("SpawnFire",pos,ALLOW_REPLACE);
			A_AlertMonsters();
			let iii=BlockThingsIterator.Create(self,96);
			while(iii.next()){
				actor vvv=iii.thing;
				if(
					vvv
					&&vvv!=sss
					&&vvv.bshootable
					&&vvv.health>0
					&&target.ishostile(vvv)
					&&checksight(vvv)
				)A_VileImmolate(vvv,random(12,34));
			}
		}
		stop;
	}
}
class mdt_deathfader:inventory{
	override void DoEffect(){
		if(owner.bcorpse)owner.A_FadeOut(0.03);
		else{
			target=owner.target;
			if(
				!(level.time&63)
				&&(
					!target
					||!owner.checksight(target)
				)
			){
				if(owner.health<2)owner.deathsound="";
				owner.damagemobj(null,null,1,"fire",DMG_NO_PAIN);
			}
		}
	}
}
class mdt_vileflame:actor{
	default{
		+nointeraction
		renderstyle "add";
	}
	void A_MDTStartFire(){
		A_StartSound("vile/firestrt",CHAN_BODY,CHANF_OVERLAP);
		A_Fire();
	}
	void A_MDTFireCrackle(){
		A_StartSound("vile/firecrkl",CHAN_BODY,CHANF_OVERLAP);
		A_Fire();
	}
	override void Tick(){
		super.Tick();
		if(
			stamina>0
			&&!(level.time&3)
			&&!isfrozen()
			&&tracer
		){
			tracer.damagemobj(self,target,1,"fire");
			stamina--;
		}
	}
	states{
	spawn:
		FIRE A 2 bright nodelay A_MDTStartFire;
		FIRE BAB 2 bright A_Fire;
		FIRE C 2 bright A_MDTFireCrackle;
		FIRE BCBCDCDCDEDED 2 bright A_Fire;
		FIRE E 2 Bright A_MDTFireCrackle;
		FIRE FEFEFGHGHGH 2 bright A_Fire;
		FIRE H 0{
			if(tracer&&stamina>0)tracer.damagemobj(self,target,stamina,"fire");
		}
		stop;
	}
}
class mdt_archvile:archvile replaces archvile{
	mixin mdt_monster;
	default{
		health 800;
		maxtargetrange 1024;
		minmissilechance 100;
		painchance 30;
	}
	void A_VileShot(){
		actor sss=spawn("mdt_vileshot",(pos.x,pos.y,pos.z+32));
		sss.target=self;
		sss.angle=angle;
		sss.pitch=pitch;
		sss.A_ChangeVelocity(34*cos(pitch),0,34*-sin(pitch),CVF_RELATIVE);
		sss.A_StartSound("brain/spit",CHAN_VOICE);
	}
	states{
	see:
		VILE AABBCCDDEEFF 2 A_VileChase;
		loop;
	missile:
		VILE G 3 bright A_VileStart;
		VILE GH 8 bright A_MDTFaceTarget(0,0);
		VILE HIJKLMN 3 bright A_MDTFaceTarget(12,12);
		VILE O 8 bright A_VileShot;
		VILE P 16 bright;
		goto see;
	heal:
		VILE [\] 10 bright;
		goto see;
	pain:
		VILE Q 5;
		VILE Q 5 A_Pain;
		VILE A 0 A_JumpIf(target,"missile");
		goto see;
	}
}

class mdt_bonerballbooster:thinker{
	actor tracer;
	override void tick(){
		if(!tracer||!tracer.bmissile||!tracer.bseekermissile){destroy();return;}
		if(tracer.getage()>TICRATE*7){
			tracer.A_StartSound(tracer.seesound,CHAN_VOICE,CHANF_OVERLAP);
			tracer.bseekermissile=false;
			tracer.tracer=null;
			tracer.speed*=4;
			mdt_handlers.ProjectileLeadTarget(tracer);
			tracer.vel*=0.6;
			let ttt=tracer.spawn(tracer.getclass(),tracer.pos);
			ttt.deathsound=ttt.seesound;
			ttt.explodemissile(null,null);
			ttt.vel=tracer.vel*0.2;
			ttt.vel.z+=1.;
			destroy();
			return;
		}
	}
}
class mdt_revenant:revenant replaces revenant{
	mixin mdt_monster;
	default{
		radius 16;
		speed 12;
		painchance 20;
		health 240;
		mass 200;
	}
	void A_MDTSkelMissile(){
		if(!target)return;
		actor missile=spawnmissile(target,"RevenantTracer");
		if(missile){
			missile.SetOrigin(missile.Vec3Offset(missile.Vel.X,missile.Vel.Y,16),false);
			missile.tracer=target;
			let bbb=new("mdt_bonerballbooster");
			bbb.tracer=missile;
		}
	}
	states{
	melee:
		SKEL G 0 A_SkelWhoosh;
		SKEL GG 3 fast A_StepForward(true);
		SKEL HHH 2 fast A_StepForward(false);
		SARG I 0 fast A_SkelFist;
		SKEL I 3 fast A_StepForward(false);
		goto see;
	missile:
		SKEL KEF 5 A_FaceTarget();
		SKEL J 2 A_MDTFaceTarget(0,0);
		SKEL J 3 bright A_MDTSkelMissile();
		SKEL KKED 3 A_FaceTarget();
		goto see;
	}
}

class mdt_cyberdemon:cyberdemon replaces cyberdemon{
	mixin mdt_monster;
	void A_MDTCybAtk(){
		A_SpawnProjectile("mdt_rocket",flags:CMF_AIMDIRECTION,pitch:pitch);
	}
	states{
	missile:
		CYBR EE 3 A_MDTFaceTarget(0,0);
		CYBR F 6 bright A_MDTCybAtk();
		CYBR EE 5 A_MDTFaceTarget(0,0);
		CYBR F 6 bright A_MDTCybAtk();
		CYBR EE 5 A_MDTFaceTarget(0,0);
		CYBR F 6 bright A_MDTCybAtk();
		CYBR E 12;
		goto see;
	}
}

class mdt_spidermastermind:spidermastermind replaces spidermastermind{
	mixin mdt_monster;
	default{
		radius 64;
		decal "BulletChip";
		attacksound "";
	}
	double shootangle;
	void A_MDTSpidAtk(){
		if(absangle(angle,shootangle)>35)setstatelabel("missileabort");
		else{
			A_CustomBulletAttack(
				frandom(-3,3),frandom(-3,3),1,4,"mdt_monsterpuff",
				0,CBAF_AIMFACING|CBAF_EXPLICITANGLE
			);
			A_MDTFaceTarget(3,3);
			A_StartSound("weapons/pistol",CHAN_WEAPON,CHANF_OVERLAP);
		}
	}
	states{
	missile:
		SPID A 4 A_Metal();
		SPID BC 4 A_MDTFaceTarget(0,0);
		SPID D 4 A_Metal();
		SPID EF 4 A_FaceTarget(0,0);
		SPID A 20{
			A_MDTFaceTarget(0,0);
			shootangle=angle;
		}
	missile2:
		SPID GHGHGHGHGHGHGH 1 bright A_MDTSpidAtk();
		SPID H 0 A_Jump(32,"see");
		SPID A 0 A_JumpIfTargetInLOS("missile2");
	missileabort:
		SPID A 10;
		goto see;
	}
}



/*
class mdt_fatso:fatso replaces fatso{
}

class mdt_painelemental:painelemental replaces painelemental{
}
*/
